/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest{}

// AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest struct for AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest
type AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest struct {
	CallbackUrl *string                          `json:"callbackUrl,omitempty"`
	Config      *GoogleSheetsCustomDtoAuthorizer `json:"config,omitempty"`
}

// NewAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest instantiates a new AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest() *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest {
	this := AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest{}
	var callbackUrl string = "https://my.app.com/callback?code=aaaaBBBBccc1234"
	this.CallbackUrl = &callbackUrl
	return &this
}

// NewAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequestWithDefaults instantiates a new AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequestWithDefaults() *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest {
	this := AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest{}
	var callbackUrl string = "https://my.app.com/callback?code=aaaaBBBBccc1234"
	this.CallbackUrl = &callbackUrl
	return &this
}

// GetCallbackUrl returns the CallbackUrl field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) GetCallbackUrl() string {
	if o == nil || IsNil(o.CallbackUrl) {
		var ret string
		return ret
	}
	return *o.CallbackUrl
}

// GetCallbackUrlOk returns a tuple with the CallbackUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) GetCallbackUrlOk() (*string, bool) {
	if o == nil || IsNil(o.CallbackUrl) {
		return nil, false
	}
	return o.CallbackUrl, true
}

// HasCallbackUrl returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) HasCallbackUrl() bool {
	if o != nil && !IsNil(o.CallbackUrl) {
		return true
	}

	return false
}

// SetCallbackUrl gets a reference to the given string and assigns it to the CallbackUrl field.
func (o *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) SetCallbackUrl(v string) {
	o.CallbackUrl = &v
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) GetConfig() GoogleSheetsCustomDtoAuthorizer {
	if o == nil || IsNil(o.Config) {
		var ret GoogleSheetsCustomDtoAuthorizer
		return ret
	}
	return *o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) GetConfigOk() (*GoogleSheetsCustomDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Config) {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) HasConfig() bool {
	if o != nil && !IsNil(o.Config) {
		return true
	}

	return false
}

// SetConfig gets a reference to the given GoogleSheetsCustomDtoAuthorizer and assigns it to the Config field.
func (o *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) SetConfig(v GoogleSheetsCustomDtoAuthorizer) {
	o.Config = &v
}

func (o AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.CallbackUrl) {
		toSerialize["callbackUrl"] = o.CallbackUrl
	}
	if !IsNil(o.Config) {
		toSerialize["config"] = o.Config
	}
	return toSerialize, nil
}

type NullableAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest struct {
	value *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest
	isSet bool
}

func (v NullableAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) Get() *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest {
	return v.value
}

func (v *NullableAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) Set(val *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest(val *AppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) *NullableAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest {
	return &NullableAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerGoogleSheetsCustomGoogleSheetsCustomAuthorizerNewOAuthCallbackRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
